<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------


namespace app\adminapi\controller\group_activity;


use app\adminapi\controller\BaseAdminController;
use app\adminapi\lists\group_activity\GroupActivityCategoryLists;
use app\adminapi\logic\group_activity\GroupActivityCategoryLogic;
use app\adminapi\validate\group_activity\GroupActivityCategoryValidate;


/**
 * 拼团活动分类控制器
 * Class GroupActivityCategoryController
 * @package app\adminapi\controller\group_activity
 */
class GroupActivityCategoryController extends BaseAdminController
{

    /**
     * @notes 获取列表
     * @return \think\response\Json
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public function lists()
    {
        return $this->dataLists(new GroupActivityCategoryLists());
    }


    /**
     * @notes 添加
     * @return \think\response\Json
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public function add()
    {
        $params = (new GroupActivityCategoryValidate())->post()->goCheck('add');
        $result = GroupActivityCategoryLogic::add($params);
        if (true === $result) {
            return $this->success('添加成功', [], 1, 1);
        }
        return $this->fail(GroupActivityCategoryLogic::getError());
    }


    /**
     * @notes 编辑
     * @return \think\response\Json
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public function edit()
    {
        $params = (new GroupActivityCategoryValidate())->post()->goCheck('edit');
        $result = GroupActivityCategoryLogic::edit($params);
        if (true === $result) {
            return $this->success('编辑成功', [], 1, 1);
        }
        return $this->fail(GroupActivityCategoryLogic::getError());
    }


    /**
     * @notes 删除
     * @return \think\response\Json
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public function delete()
    {
        $params = (new GroupActivityCategoryValidate())->post()->goCheck('delete');
        GroupActivityCategoryLogic::delete($params);
        return $this->success('删除成功', [], 1, 1);
    }


    /**
     * @notes 获取详情
     * @return \think\response\Json
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public function detail()
    {
        $params = (new GroupActivityCategoryValidate())->goCheck('detail');
        $result = GroupActivityCategoryLogic::detail($params);
        return $this->data($result);
    }
    /**
     * 获取活动分类二维码
     */
    public function getQRCode()
    {
        $params = (new GroupActivityCategoryValidate())->post()->goCheck('detail');
        return $this->success('',['qrcode'=>GroupActivityCategoryLogic::getQRCode($params, $this->request->domain())], 1, 1);
    }

    /**
     * 分类活动统计
     */
    public function total() 
    {
        $id = (int)$this->request->param('id');
        $result = GroupActivityCategoryValidate::total($id);
        return $this->data($result);
    }

    /**
     * @notes 复制活动分类
     * @return \think\response\Json
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public function copy()
    {
        $params = (new GroupActivityCategoryValidate())->goCheck('detail');
        $result = GroupActivityCategoryLogic::copy($params);
        if (true === $result) {
            return $this->success('复制成功', [], 1, 1);
        } 
        return $this->fail(GroupActivityCategoryLogic::getError());
    }
}